<?php
/**
 * @file
 * Contains form for customer setup.
 */

/**
 * Customer setup form().
 */
include "mo_saml_visualTour.php";

function miniorange_saml_customer_setup($form, &$form_state)
{
    global $base_url;

    drupal_add_css( drupal_get_path('module', 'miniorange_saml'). '/css/bootstrap.min.css' , array('group' => CSS_DEFAULT, 'every_page' => FALSE));
    drupal_add_css( drupal_get_path('module', 'miniorange_saml'). '/css/style_settings.css' , array('group' => CSS_DEFAULT, 'every_page' => FALSE));

    $form['markup_msg'] = array(
        '#markup' => '<div class="mo_saml_idp_message"><p>If you are looking for an Identity Provider, you can try out <a href="https://idp.miniorange.com" target="_blank" style="color: #83cfff;">miniOrange On-Premise IdP</a></p></div>'
    );

  $current_status = variable_get('miniorange_saml_status', '');
  if ($current_status == 'VALIDATE_OTP') {

      $form['header_top_style_1'] = array('#markup' => '<div class="mo_saml_table_layout_1">');

      $form['markup_14'] = array(
          '#markup' => '<div class="mo_saml_table_layout mo_saml_container">',
      );

    $form['miniorange_saml_customer_otp_token'] = array(
      '#type' => 'textfield',
      '#title' => t('OTP'),
      '#attributes' => array('style' => 'width:45%'),
    );

    $form['miniorange_saml_customer_validate_otp_button'] = array(
      '#type' => 'submit',
      '#value' => t('Validate OTP'),
      '#submit' => array('miniorange_saml_validate_otp_submit'),
    );

    $form['miniorange_saml_customer_setup_resendotp'] = array(
      '#type' => 'submit',
      '#value' => t('Resend OTP'),
      '#submit' => array('miniorange_saml_resend_otp'),
    );

    $form['miniorange_saml_customer_setup_back'] = array(
      '#type' => 'submit',
      '#value' => t('Back'),
      '#submit' => array('miniorange_saml_back'),
    );




      $form['markup_support_close1'] = array(
          '#markup' => '</div>',
      );

      Utilities::supportForm($form, $form_state);

      $form['miniorange_saml_support_submit_click'] = array(
          '#type' => 'submit',
          '#value' => t('Submit Query'),
          '#submit' => array('send_support_query'),
          '#attributes' => array('style' => 'background: #337ab7;color: #ffffff;text-shadow: 0 -1px 1px #337ab7, 1px 0 1px #337ab7, 0 1px 1px #337ab7, -1px 0 1px #337ab7;box-shadow: 0 1px 0 #337ab7;border-color: #337ab7 #337ab7 #337ab7;'),
      );

      $form['miniorange_saml_support_note'] = array(
          '#markup' => '<div>If you want custom features in the plugin, just drop an email to <a href="mailto:info@miniorange.com">info@miniorange.com</a></div></div></div>'
      );

    return $form;
  }
  elseif ($current_status == 'PLUGIN_CONFIGURATION')
  {

      $form['header_top_style_1'] = array('#markup' => '<div class="mo_saml_table_layout_1">');

      $form['markup_1'] = array(
          '#markup' => '<div class="mo_saml_table_layout mo_saml_container">');

      // Show customer configuration here.
    $form['markup_top'] = array(
      '#markup' => '<div class="mo_saml_welcome_message">Thank you for registering with miniOrange</div>'
      . '<br><h4>Your Profile: </h4>');


    $header = array(
      'email' => array('data' => t('Customer Email')),
      'customerid' => array('data' => t('Customer ID')),
      'token' => array('data' => t('Token Key')),
      'apikey' => array('data' => t('API Key')),
    );

    $options = array();

    $options[0] = array(
      'email' => variable_get('miniorange_saml_customer_admin_email', ''),
      'customerid' => variable_get('miniorange_saml_customer_id', ''),
      'token' => variable_get('miniorange_saml_customer_admin_token', ''),
      'apikey' => variable_get('miniorange_saml_customer_api_key', ''),
    );

    $form['fieldset']['customerinfo'] = array(
      '#theme' => 'table',
      '#header' => $header,
      '#rows' => $options,
    );

      $form['miniorange_saml_customer_Remove_Account_info'] = array('#markup' => '<br><br><br><br/><br/>'.'<h4>Remove Account: <a href="' . $base_url . '/admin/config/people/miniorange_saml/licensing"> <b>[Standard, Premium, Enterprise]</b></a></br></h4>'.'<p>This section will help you to remove your current logged in account without losing your current configurations.</p>');

      $form['miniorange_saml_remove_account_button'] = array(
          '#type' => 'submit',
          '#value' => t('Remove Account '),
          '#disabled' => TRUE,
          '#attributes'=>array('id'=>'mosaml_vt_removeAcc'),
      );


      $form['markup_support_close1'] = array(
          '#markup' => '</div>',
      );

      Utilities::supportForm($form, $form_state);

      $form['miniorange_saml_support_submit_click'] = array(
          '#type' => 'submit',
          '#value' => t('Submit Query'),
          '#submit' => array('send_support_query'),
          '#attributes' => array('style' => 'background: #337ab7;color: #ffffff;text-shadow: 0 -1px 1px #337ab7, 1px 0 1px #337ab7, 0 1px 1px #337ab7, -1px 0 1px #337ab7;box-shadow: 0 1px 0 #337ab7;border-color: #337ab7 #337ab7 #337ab7;'),
      );

      $form['miniorange_saml_support_note'] = array(
          '#markup' => '<div>If you want custom features in the plugin, just drop an email to <a href="mailto:info@miniorange.com">info@miniorange.com</a></div></div></div>'
      );

    return $form;
  }

  $form['header_top_style_1'] = array('#markup' => '<div class="mo_saml_table_layout_1">');

    $form['markup_14'] = array(
        '#markup' => '<div class="mo_saml_table_layout mo_saml_container" id="mo_saml_vt_register"><b><span style="font-size: 19px;">Register/Login with miniOrange</span></b><br><br><hr><br/>',
    );

  $form['markup_15'] = array(
    '#markup' => '<div class="mo_saml_highlight_background_note_1">You should register so that in case you need help, we can help you with step by step instructions.
                    We support all known IdPs - ADFS, Okta, Salesforce, Shibboleth, SimpleSAMLphp, OpenAM, Centrify, Ping, RSA, IBM, Oracle, OneLogin, Bitium, WSO2 etc. 
                    <b>You will also need a miniOrange account to upgrade to the standard, premium and enterprise versions of the modules.</b> We do not store any information except the email that you will use to register with us.</div><br><br>',
  );

  $form['miniorange_saml_customer_setup_username'] = array(
    '#type' => 'textfield',
    '#title' => t('Email'),
    '#attributes' => array('style' => 'width:60%'),
  );

    $form['miniorange_saml_customer_setup_phone'] = array(
        '#type' => 'textfield',
        '#title' => t('Phone'),
        '#attributes' => array('style' => 'width:60%'),
    );

    $form['miniorange_saml_customer_setup_password'] = array(
    '#type' => 'password_confirm',
  );

  $form['miniorange_saml_customer_setup_button'] = array(
    '#type' => 'submit',
    '#value' => t('Register'),
    '#submit' => array('miniorange_saml_customer_setup_submit'),
      '#attributes' => array('style' => 'background: #337ab7;color: #ffffff;text-shadow: 0 -1px 1px #337ab7, 1px 0 1px #337ab7, 0 1px 1px #337ab7, -1px 0 1px #337ab7;box-shadow: 0 1px 0 #337ab7;border-color: #337ab7 #337ab7 #337ab7;'),
  );

    $form['markup_support_close1'] = array(
        '#markup' => '</div>',
    );

    Utilities::supportForm($form, $form_state);

    $form['miniorange_saml_support_submit_click'] = array(
        '#type' => 'submit',
        '#value' => t('Submit Query'),
        '#submit' => array('send_support_query'),
        '#attributes' => array('style' => 'background: #337ab7;color: #ffffff;text-shadow: 0 -1px 1px #337ab7, 1px 0 1px #337ab7, 0 1px 1px #337ab7, -1px 0 1px #337ab7;box-shadow: 0 1px 0 #337ab7;border-color: #337ab7 #337ab7 #337ab7;display:block;margin-left:auto;margin-right:auto;'),
    );

    $form['miniorange_saml_support_note'] = array(
        '#markup' => '<div>If you want custom features in the plugin, just drop an email to <a href="mailto:info@miniorange.com">info@miniorange.com</a></div></div></div>'
    );

  return $form;

}

/**
 * Validate OTP.
 */
function miniorange_saml_validate_otp_submit(&$form, $form_state) {

  global $base_url;
  $otp_token = $form['miniorange_saml_customer_otp_token']['#value'];
  $username = variable_get('miniorange_saml_customer_admin_email', NULL);
  $phone = variable_get('miniorange_saml_customer_admin_phone', NULL);
  $tx_id = variable_get('miniorange_saml_tx_id', NULL);
  $customer_config = new MiniorangeSAMLCustomer($username, $phone, NULL, $otp_token);

  // Validate OTP.
  $validate_otp_response = json_decode($customer_config->validateOtp($tx_id));
  if ($validate_otp_response->status == 'SUCCESS') {
    // OTP Validated. Show Configuration page.
    $current_status = 'PLUGIN_CONFIGURATION';
    variable_set('miniorange_saml_status', $current_status);
    variable_del('miniorange_saml_tx_id');

    // OTP Validated. Create customer.
    $password = variable_get('miniorange_saml_customer_admin_password', '');
    $customer_config = new MiniorangeSAMLCustomer($username, $phone, $password, NULL);
    $create_customer_response = json_decode($customer_config->createCustomer());
    if ($create_customer_response->status == 'SUCCESS') {
      // Customer created.
      $current_status = 'PLUGIN_CONFIGURATION';
      variable_set('miniorange_saml_status', $current_status);
      variable_set('miniorange_saml_customer_admin_email', $username);
      variable_set('miniorange_saml_customer_admin_phone', $phone);
      variable_set('miniorange_saml_customer_admin_token', $create_customer_response->token);
      variable_set('miniorange_saml_customer_id', $create_customer_response->id);
      variable_set('miniorange_saml_customer_api_key', $create_customer_response->apiKey);

      drupal_set_message(t('Customer account created. Please read the instructions to setup your SAML Plugin in the next section'));

        $redirect = $base_url.'/admin/config/people/miniorange_saml/licensing';
        drupal_goto($redirect);
  
    }
    else {
      drupal_set_message(t('Error creating customer'), 'error');
    }
  }
  else {
    drupal_set_message(t('Error validating OTP'), 'error');
  }

}

/**
 * Resend OTP.
 */
function miniorange_saml_resend_otp(&$form, $form_state) {

  variable_del('miniorange_saml_tx_id');
  $username = variable_get('miniorange_saml_customer_admin_email', NULL);
  $phone = variable_get('miniorange_saml_customer_admin_phone', NULL);
  $customer_config = new MiniorangeSAMLCustomer($username, $phone, NULL, NULL);
  $send_otp_response = json_decode($customer_config->sendOtp());
  if ($send_otp_response->status == 'SUCCESS') {
    // Store txID.
    variable_set('miniorange_saml_tx_id', $send_otp_response->txId);
    $current_status = 'VALIDATE_OTP';
    variable_set('miniorange_saml_status', $current_status);
    drupal_set_message(t('Verify email address by entering the passcode sent to @username', array('@username' => $username)));
  }
}

/**
 * Handle submit for customer setup.
 */
function miniorange_saml_customer_setup_submit(&$form, $form_state)
{
    global $base_url;
  $username = $form['miniorange_saml_customer_setup_username']['#value'];
  $phone = $form['miniorange_saml_customer_setup_phone']['#value'];
  $password = $form['miniorange_saml_customer_setup_password']['#value']['pass1'];
  if(empty($username)||empty($password)){
      if(empty($username)) {
          drupal_set_message(t('The <b>Email Address</b> field is required.'), 'error');
      }
      if(empty($password)) {
          drupal_set_message(t('The <b>Password</b> field is required.'), 'error');
      }
      return;
  }

  $customer_config = new MiniorangeSAMLCustomer($username, $phone, $password, NULL);
  $check_customer_response = json_decode($customer_config->checkCustomer());

  //print_r($check_customer_response->status);exit;
  if ($check_customer_response->status == 'CUSTOMER_NOT_FOUND') {
    // Create customer.
    // Store email and phone.
    variable_set('miniorange_saml_customer_admin_email', $username);
    variable_set('miniorange_saml_customer_admin_phone', $phone);
    variable_set('miniorange_saml_customer_admin_password', $password);

    $send_otp_response = json_decode($customer_config->sendOtp());
    if ($send_otp_response->status == 'SUCCESS') {
      // Store txID.
      variable_set('miniorange_saml_tx_id', $send_otp_response->txId);
      $current_status = 'VALIDATE_OTP';
      variable_set('miniorange_saml_status', $current_status);
      drupal_set_message(t('Verify email address by entering the passcode sent to @username', array('@username' => $username)));
    }
  }
  elseif ($check_customer_response->status == 'CURL_ERROR') {
    drupal_set_message(t('cURL is not enabled. Please enable cURL'), 'error');
  }
  else {
    // Customer exists. Retrieve keys.
    $customer_keys_response = json_decode($customer_config->getCustomerKeys());
    if (json_last_error() == JSON_ERROR_NONE) {
      variable_set('miniorange_saml_customer_id', $customer_keys_response->id);
      variable_set('miniorange_saml_customer_admin_token', $customer_keys_response->token);
      variable_set('miniorange_saml_customer_admin_email', $username);
      variable_set('miniorange_saml_customer_admin_phone', $phone);
      variable_set('miniorange_saml_customer_api_key', $customer_keys_response->apiKey);
      $current_status = 'PLUGIN_CONFIGURATION';
      variable_set('miniorange_saml_status', $current_status);
      drupal_set_message(t('Successfully retrieved your account.'));

        $redirect = $base_url.'/admin/config/people/miniorange_saml/licensing';
        drupal_goto($redirect);

    }
     else if($check_customer_response->status=='TRANSACTION_LIMIT_EXCEEDED')
      {
          drupal_set_message(t('The transaction limit has been exceeded'), 'error');
      }
    else {
      drupal_set_message(t('Invalid credentials'), 'error');
    }
  }
}

/**
 * Handle back button submit for customer setup.
 */
function miniorange_saml_back(&$form, $form_state) {
  $current_status = 'CUSTOMER_SETUP';
  variable_set('miniorange_saml_status', $current_status);
  variable_del('miniorange_saml_customer_admin_email');
  variable_del('miniorange_saml_customer_admin_phone');
  variable_del('miniorange_saml_tx_id');
  drupal_set_message(t('Register/Login with your miniOrange Account'));
}

/**
 * Send support query.
 */
function send_support_query(&$form, $form_state)
{
    Utilities::send_query($form, $form_state);
}