
<?php

/**
 * @file
 * Contains support form for miniOrange SAML Login Module.
 */
include "includes\miniorange_saml_enum.php";
include "mo_saml_visualTour.php";

define( "Tab_Class_Names", serialize( array(
    "Identity_Provider" => 'mo_options_enum_identity_provider',
    "Service_Provider"  => 'mo_options_enum_service_provider',
    "Proxy_Setup"       => 'mo_options_enum_proxy_setup'
) ) );
/**
 * Showing Support form info.
 */
function miniorange_saml_export_config($form, &$form_state)
{
    drupal_add_css( drupal_get_path('module', 'miniorange_saml'). '/css/bootstrap.min.css' , array('group' => CSS_DEFAULT, 'every_page' => FALSE));
    drupal_add_css( drupal_get_path('module', 'miniorange_saml'). '/css/style_settings.css' , array('group' => CSS_DEFAULT, 'every_page' => FALSE));

    global $base_url;

    $form['markup_msg'] = array(
        '#markup' => '<div class="mo_saml_idp_message"><p>If you are looking for an Identity Provider, you can try out <a href="https://idp.miniorange.com" target="_blank" style="color: #83cfff;">miniOrange On-Premise IdP</a></p></div>'
    );

    $form['header_top_style_1'] = array('#markup' => '<div class="mo_saml_table_layout_1">');

    $form['header_top_style_tops'] = array('#markup' => '<div class="mo_saml_table_layout mo_saml_container">');

    $form['markup_top'] = array(
        '#markup' => '<b><span style="font-size: 17px;">EXPORT CONFIGURATION</span></b><a class="btn btn-primary btn-large restart_button" id="restart_tour_button">'
            . 'Take a Tour</a><br><br><hr><br/>'
    );

    $form['markup_div']=array('#markup'=>'<div id="mosaml_vt_impexp">');

    $form['markup_1'] = array(
        '#markup' => '<p>This tab will help you to transfer your plugin configurations when you change your Drupal instance.</p>'
            . '<p>Download plugin configuration file by clicking on the button given below and send us this file along with your support query. </p>',
    );

    if(miniorange_saml_is_sp_configured()) {
        $form['miniorange_saml_idp_export'] = array(
            '#type' => 'submit',
            '#value' => t('Download Plugin Configuration'),
            '#prefix' => '<td>',
            '#suffix' => '</td>',
            '#submit' => array('miniorange_import_export'),
            '#attributes' => array('id'=>'mosaml_vt_export'),
        );
    }else {
        $form['miniorange_saml_idp_export'] = array(
            '#markup' => '<div style="display:block; margin-top:10px; color:red; background-color:rgba(251, 232, 0, 0.15); font-size: medium;padding:5px;border:solid 1px rgba(255, 0, 9, 0.36);">
	                            Please <a href="' . $base_url . '/admin/config/people/miniorange_saml">configure the plugin</a> first to export the configurations.
                          </div>',
        );
    }

    $form['markup_div1']=array('#markup'=>'</div>');

    $form['markup_div_imp1']=array('#markup'=>'<div id="mosaml_vt_import">');

    $form['markup_import'] = array(
        '#markup' => '<br><h4>IMPORT CONFIGURATION</h4><hr><br>',
    );

    $form['markup_prem_plan'] = array(
        '#markup' => '<div class="mo_saml_highlight_background_note">Available in <b><a href="' . $base_url . '/admin/config/people/miniorange_saml/Licensing">Standard, Premium, Enterprise</a></b> versions of the module</div>',
    );

    $form['markup_import_note'] = array(
        '#markup' => '<p>This tab will help you to<span style="font-weight: bold"> Import your plugin configurations</span> when you change your Drupal instance.</p>
               <p>choose <b>"json"</b> Extened plugin configuration file and upload by clicking on the button given below. </p>',
    );

    $form['import_Config_file'] = array(
        '#type' => 'file',
        '#disabled' => TRUE,
        '#attributes' => array('id'=>'mosaml_vt_import'),
    );

    $form['miniorange_saml_idp_import'] = array(
        '#type' => 'submit',
        '#value' => t('Upload'),
        '#submit' => array('miniorange_import_Config'),
        '#disabled' => TRUE,
    );

    $form['markup_div_imp11']=array('#markup'=>'</div></div>');

    Utilities::supportForm($form, $form_state);

    $form['miniorange_saml_support_submit_click'] = array(
        '#type' => 'submit',
        '#value' => t('Submit Query'),
        '#submit' => array('send_support_query'),
        '#attributes' => array('style' => 'background: #337ab7;color: #ffffff;text-shadow: 0 -1px 1px #337ab7, 1px 0 1px #337ab7, 0 1px 1px #337ab7, -1px 0 1px #337ab7;box-shadow: 0 1px 0 #337ab7;border-color: #337ab7 #337ab7 #337ab7;display:block;margin-left:auto;margin-right:auto;'),
    );

    $form['miniorange_saml_support_note'] = array(
        '#markup' => '<div>If you want custom features in the plugin, just drop an email to <a href="mailto:info@miniorange.com">info@miniorange.com</a></div></div></div>'
    );


    return $form;
}

function miniorange_import_export() {

    $tab_class_name      = unserialize( Tab_Class_Names );
    $configuration_array = array();
    foreach ( $tab_class_name as $key => $value ) {
        $configuration_array[ $key ] = mo_get_configuration_array( $value );
    }

    $configuration_array["Version_dependencies"]=mo_get_version_informations();

    header( "Content-Disposition: attachment; filename=miniorange-saml-config.json" );
    echo( json_encode( $configuration_array, JSON_PRETTY_PRINT|JSON_UNESCAPED_SLASHES) );
    exit;
}

function mo_get_configuration_array( $class_name ) {
    $class_object = call_user_func( $class_name . '::getConstants' );
    $mo_array = array();

    foreach ( $class_object as $key => $value ) {

        $mo_option_exists=variable_get($value);
        if($mo_option_exists){
            if(@unserialize($mo_option_exists)!==false){
                $mo_option_exists = unserialize($mo_option_exists);
            }
            $mo_array[ $key ] = $mo_option_exists;
        }
    }
    return $mo_array;
}

function mo_get_version_informations(){
    $array_version = array();
    $array_version["PHP_version"] = phpversion();
    $array_version["Drupal_version"] = VERSION;
    $array_version["OPEN_SSL"] = mo_saml_is_openssl_installed();
    $array_version["CURL"] = mo_saml_is_curl_installed();
    $array_version["ICONV"] = mo_saml_is_iconv_installed();
    $array_version["DOM"] = mo_saml_is_dom_installed();

    return $array_version;
}

function mo_saml_is_openssl_installed() {
    if ( in_array( 'openssl', get_loaded_extensions() ) ) {
        return 1;
    } else {
        return 0;
    }
}

function mo_saml_is_curl_installed() {
    if ( in_array( 'curl', get_loaded_extensions() ) ) {
        return 1;
    } else {
        return 0;
    }
}

function mo_saml_is_iconv_installed(){

    if ( in_array( 'iconv', get_loaded_extensions() ) ) {
        return 1;
    } else {
        return 0;
    }
}

function mo_saml_is_dom_installed(){

    if ( in_array( 'dom', get_loaded_extensions() ) ) {
        return 1;
    } else {
        return 0;
    }
}

function miniorange_saml_is_sp_configured() {
    $saml_login_url  = variable_get( 'miniorange_saml_idp_login_url' );
    $saml_idp_issuer = variable_get( 'miniorange_saml_idp_issuer' );
    $saml_x509_certificate = variable_get( 'miniorange_saml_idp_x509_certificate' );
    if ( ! empty( $saml_login_url ) && ! empty( $saml_x509_certificate )  && ! empty( $saml_idp_issuer ) ) {
        return 1;
    } else {
        return 0;
    }
}

/**
 * Send support query.
 */
function send_support_query(&$form, $form_state)
{
    Utilities::send_query($form, $form_state);
}