<?php
/**
 * @file
 * Contains Service Provider information for miniOrange SAML Login Module.
 */

 /**
 * Showing IdP Setup form info.
 */

include "includes/MetadataReader.php";
include "mo_saml_visualTour.php";
 function miniorange_saml_idp_setup($form, &$form_state)
 {
     drupal_add_css( drupal_get_path('module', 'miniorange_saml'). '/css/bootstrap.min.css' , array('group' => CSS_DEFAULT, 'every_page' => FALSE));
     drupal_add_css( drupal_get_path('module', 'miniorange_saml'). '/css/style_settings.css' , array('group' => CSS_DEFAULT, 'every_page' => FALSE));

     global $base_url;

     $form['markup_msg'] = array(
         '#markup' => '<div class="mo_saml_idp_message"><p>If you are looking for an Identity Provider, you can try out <a href="https://idp.miniorange.com" target="_blank" style="color: #83cfff;">miniOrange On-Premise IdP</a></p></div>'
     );

  $form['header_top_style_1'] = array('#markup' => '<div class="mo_saml_table_layout_1">');

  $form['markup_top'] = array(
      '#markup' => '<div class="mo_saml_table_layout mo_saml_container">',
  );

  $form['miniorange_saml_IDP_tab'] = array(
  '#markup' => '<div id="tabhead"><h5> Enter the information gathered from your Identity Provider &nbsp; OR &nbsp;<a class="btn btn-primary btn-large" 
                  id="mosaml_upload" style="padding:5px 10px;margin-left: 0px;" onclick="show_metadata_form()">Upload IDP Metadata</a>
                 <a class="btn btn-primary btn-large restart_button" id="restart_tour_button" style="margin-right: 0px;" >Take a Tour</a></h5></div><hr>',
  );

  $form['metadata_1'] = array(
	'#markup' =>'<div border="1" id="upload_metadata_form" style="background-color:#FFFFFF; border:2px solid #CCCCCC; padding:1px 1px 1px 10px; display:none;" >'
  . '		<table style="width:100%;">'
  .'		<tr> <td colspan="3">'
  .'				<h1>Upload IDP Metadata'
  .'					<span style="float:right;margin-right:25px;">'
  .'						<input type="button" class="btn btn-sm btn-danger" value="Cancel" onclick = "hide_metadata_form()"/></a><br>'
  .'					</span><br><br><hr>',
  );

     $form['metadata_idp_name'] = array(
         '#markup' =>'</td></td>'
             .'	</tr>'
             .'				<tr><td colspan="3" ></td></tr>'
             .'		    <tr>'
             .'			<td width="20%"><h4>Identity Provider name:</h4></td><td width="10%">',
     );

     $form['miniorange_saml_idp_name_3'] = array(
         '#type' => 'textfield',
         '#attributes' => array('placeholder' => 'Enter Identity Provider name.'),
     );


     $form['metadata_2'] = array(
   '#markup' => '</span>'
  .'				</h1>'
  .'			</td>'
  .'		</tr>'
  .'			<tr>'
  .'				<td><h4>Upload Metadata  :</h4>'
  .'				<td colspan="2">',
  );
  
  $form['metadata_file'] = array(
    '#type' => 'file',
  );
  
  $form['metadata_upload'] = array(
    '#type' => 'submit',
    '#value' => t('Upload'),
    '#submit' => array('miniorange_saml_upload_file'),
      '#attributes' => array('style' => 'background: #337ab7;color: #ffffff;text-shadow: 0 -1px 1px #337ab7, 1px 0 1px #337ab7, 0 1px 1px #337ab7, -1px 0 1px #337ab7;box-shadow: 0 1px 0 #337ab7;border-color: #337ab7 #337ab7 #337ab7;'),
  );
  
  $form['metadata_3'] = array(
    '#markup' =>'</td></td>'
	.'	</tr>'
	.'				<tr><td colspan="3" ><p style="font-size:13pt;text-align:center;"><b>OR</b></p></td></tr>'
	.'		    <tr>'
	.'			<td width="20%"><h4>Enter metadata URL:</h4></td><td width="10%">',
  );

  $form['metadata_URL'] = array(
    '#type' => 'textfield',
	'#attributes' => array('placeholder' => 'Enter metadata URL of your IdP.'),
  );
  
  $form['metadata_4'] = array(
    '#markup' =>'</td><td>',
  );
	
   $form['metadata_fetch'] = array(
	'#type' => 'submit',
    '#value' => t('Fetch Metadata'),
    '#submit' => array('miniorange_saml_fetch_metadata'),
       '#attributes' => array('style' => 'background: #337ab7;color: #ffffff;text-shadow: 0 -1px 1px #337ab7, 1px 0 1px #337ab7, 0 1px 1px #337ab7, -1px 0 1px #337ab7;box-shadow: 0 1px 0 #337ab7;border-color: #337ab7 #337ab7 #337ab7;'),
   );

     $form['metadata_4'] = array(
         '#markup' =>'</td></tr><tr><td></td><td>',
     );

     $form['miniorange_saml_fetch_metadata_after_specific_time'] = array(
         '#type' => 'checkbox',
         '#title' => t('Update IdP settings by pinging metadata URL ( We will store the metadata URL )<a href="' . $base_url . '/admin/config/people/miniorange_saml/licensing"> <b>[Enterprise]</b></a>'),
         '#disabled' => TRUE,
     );


     $form['note_for metadata_fetch'] = array(
         '#markup' => '<b>Note: </b>You can set how often you want to ping the IdP from <b><a style="font-size: small;" href="">Here</a> OR</b> you can goto <b>Configuration=>Cron=>Run Cron Every</b> section of your drupal site',
     );

   $form['metadata_5'] = array(
   '#markup' => '</td></tr></table></div><br><div id="idpdata">',
   );

     $form['miniorange_saml_identity_provider_guide'] = array(
         '#type' => 'select',
         '#title' => t('Select your Identity Provider :'),
         '#options' => array(
                 'select-idp'=>t('Select your Identity Provider'),
             'adfs' => t('ADFS'),
             'okta' => t('Okta'),
             'salesforce' => t('SalesForce'),
             'google-apps' => t('Google Apps'),
             'azure-ad' => t('Azure Ad'),
             'onelogin' => t('OneLogin'),
             'centrify' => t('Centrify'),
             'miniorange' => t('MiniOrange'),
             'bitium' => t('Bitium'),
             'other' => t('Other'),
         ),
         '#attributes' => array('style' => 'width:85%;','onchange'=>'idp_guide(value);'),
         '#description' => t('<b>Note : </b>Select your Identity Provider from the list above, and you can find the link to the guide for setting up SAML.<br> Please contact us if you don\'t find your IDP in the list.'),
     );
     ?>
   <script>
       function idp_guide(value) {
            if(value!="other" && value!="select-idp") {
                window.open("https://plugins.miniorange.com/drupal-single-sign-sso-using-" + value + "-idp/", '_blank');
            }
       }
   </script>
<?php

$form['miniorange_saml_idp_name'] = array(
    '#type' => 'textfield',
    '#title' => t('IdP Name'),
    '#default_value' => variable_get('miniorange_saml_idp_name', ''),
    '#attributes' => array('style' => 'width:85%','id'=>'mosaml_vt_name','placeholder' => 'Identity Provider Name like ADFS, SimpleSAML etc.'),
  );

  $form['miniorange_saml_idp_issuer'] = array(
    '#type' => 'textfield',
    '#title' => t('IdP Entity ID or Issuer'),
	'#description' => t('<b>Note :</b> You can find the EntityID in Your IdP-Metadata XML file enclosed in <code>EntityDescriptor</code> tag having attribute<br> as <code>entityID</code>'),
    '#default_value' => variable_get('miniorange_saml_idp_issuer', ''),
    '#attributes' => array('style' => 'width:85%','id'=>'mosaml_vt_issuer','placeholder' => 'Enter IdP Entity ID url or Issuer url '),
  );
  
  $form['miniorange_saml_idp_login_url'] = array(
    '#type' => 'textfield',
    '#title' => t('SAML Login URL'),
	'#description' => t('<b>Note :</b> You can find the SAML Login URL in Your IdP-Metadata XML file enclosed in <code>SingleSignOnService</code> tag <br>(Binding type: HTTP-Redirect)'),
	'#default_value' => variable_get('miniorange_saml_idp_login_url', ''),
    '#attributes' => array('style' => 'width:85%','id'=>'mosaml_vt_loginUrl','placeholder' => 'Single Sign-On Service URL (HTTP-Redirect binding) of your IdP'),
    );



  $form['miniorange_saml_idp_x509_certificate'] = array(
    '#type' => 'textarea',
    '#title' => t('x.509 Certificate Value'),
    '#cols' => '6',
    '#rows' => '5',
    '#default_value' => variable_get('miniorange_saml_idp_x509_certificate', ''),
    '#attributes' => array('style' => 'width:85%','id'=>'mosaml_vt_x509Cert','placeholder' => 'Copy and Paste the content from the downloaded certificate or copy the content enclosed in X509Certificate tag (has parent tag KeyDescriptor use=signing) in IdP-Metadata XML file'),
    '#resizable' => False,
  );

  $form['markup_1'] = array(
    '#markup' => '<b>NOTE:</b> Format of the certificate:<br><b>-----BEGIN CERTIFICATE-----<br>XXXXXXXXXXXXXXXXXXXXXXXXXXX<br>-----END CERTIFICATE-----</b><br><br>'
  );



     $form['miniorange_vt_divstart'] = array(
         '#markup'=>'<div id="mosaml_vt_enableLogin">'
     );

  $form['miniorange_saml_enable_login'] = array(
    '#type' => 'checkbox',
    '#title' => t('Enable login with SAML'),
    '#default_value' => variable_get('miniorange_saml_enable_login', FALSE),
  );

     $form['miniorange_vt_divend'] = array(
         '#markup'=>'</div><br>'
     );

     $form['Note'] = array(
     '#markup' => '<div class="mo_saml_highlight_background_note">',
 );

     $form['miniorange_saml_sign_request'] = array(
         '#type' => 'checkbox',
         '#title' => t('Check this option to send Signed SSO and SLO requests.<a href="' . $base_url . '/admin/config/people/miniorange_saml/licensing"> <b>[Standard, Premium, Enterprise].</b></a>'),
         '#default_value' => variable_get('miniorange_saml_request_signed', FALSE),
         '#disabled' => TRUE,
     );

     $form['miniorange_saml_enable_logout'] = array(
         '#type' => 'checkbox',
         '#title' => t('<b>Check this option for logout if you do not want to wait for response.<a href="' . $base_url . '/admin/config/people/miniorange_saml/licensing"> [Premium, Enterprise]</a></b>'),
         '#description'=>'<b>Note: </b>Checking this option Users will be logout from Service Provider and Identity Provider without waiting for response from IdP.',
         '#disabled' => TRUE,
     );
     $form['miniorange_vt_divends'] = array(
         '#markup'=>'</div><br>'
     );

  $form['miniorange_saml_idp_config_submit'] = array(
         '#type' => 'submit',
         '#value' => t('Save Configuration'),
         '#prefix'=>'<td>',
         '#suffix'=>'</td>',
         '#submit' => array('miniorange_saml_save_idp_config'),
      '#attributes' => array('style' => 'background: #337ab7;color: #ffffff;text-shadow: 0 -1px 1px #337ab7, 1px 0 1px #337ab7, 0 1px 1px #337ab7, -1px 0 1px #337ab7;box-shadow: 0 1px 0 #337ab7;border-color: #337ab7 #337ab7 #337ab7;'),
  );

  $form['miniorange_saml_test_config_button'] = array(
    '#markup' => '<a class="btn btn-primary btn-large" style="padding:5px 10px;" onclick="testConfig(\'' . getTestUrl() . '\');">'
    . 'Test Configuration</a><br><br>',
  );
  
  $form['miniorange_saml_test_show_SAML_request_button'] = array(
    '#markup' => '<a class="btn btn-primary btn-large" style="padding:5px 10px;" onclick="showSAMLrequest(\'' . getSAMLrequest() . '\');">'
    . 'Show SAML Request</a>&nbsp',
  );
  
  $form['miniorange_saml_test_show_SAML_response_button'] = array(
    '#markup' => '&nbsp;&nbsp;&nbsp;&nbsp;<a class="btn btn-primary btn-large" style="padding:5px 10px;" onclick="showSAMLresponse(\'' . getSAMLresponse() . '\');">'
    . 'Show SAML Response</a><br><br>',
  );

     $form['markup_support_close1'] = array(
         '#markup' => '</div></div>',
     );

     Utilities::supportForm($form, $form_state);

     $form['miniorange_saml_support_submit_click'] = array(
         '#type' => 'submit',
         '#value' => t('Submit Query'),
         '#submit' => array('send_support_query'),
         '#attributes' => array('style' => 'background: #337ab7;color: #ffffff;text-shadow: 0 -1px 1px #337ab7, 1px 0 1px #337ab7, 0 1px 1px #337ab7, -1px 0 1px #337ab7;box-shadow: 0 1px 0 #337ab7;border-color: #337ab7 #337ab7 #337ab7;display:block;margin-left:auto;margin-right:auto;'),
     );

     $form['miniorange_saml_support_note'] = array(
         '#markup' => '<div>If you want custom features in the plugin, just drop an email to <a href="mailto:info@miniorange.com">info@miniorange.com</a></div></div></div>'
     );

  return $form;

 }
 
 function getTestUrl() {
  global $base_url;
  $testUrl = $base_url . '/?q=testConfig';
  return $testUrl;
 }
 
 function getSAMLrequest() {
  global $base_url;
  $SAMLrequestUrl = $base_url . '/?q=showSAMLrequest';
  return $SAMLrequestUrl;
 }
 
 function getSAMLresponse() {
  global $base_url;
  $SAMLresponseUrl = $base_url . '/?q=showSAMLresponse';
  return $SAMLresponseUrl;
 }

 /**
 * Configure IdP.
 */
 function miniorange_saml_save_idp_config($form, &$form_state) {
 
  global $base_url;
  $idp_name = $form['miniorange_saml_idp_name']['#value'];
  $issuer = $form['miniorange_saml_idp_issuer']['#value'];
  $nameid_format = "urn:oasis:names:tc:SAML:1.1:nameid-format:unspecified"; 
  $login_url = $form['miniorange_saml_idp_login_url']['#value'];
  $x509_cert_value = Utilities::sanitize_certificate($form['miniorange_saml_idp_x509_certificate']['#value']);
  $enable_login = $form['miniorange_saml_enable_login']['#value'];
     if(empty($idp_name)||empty($issuer)||empty($login_url)){
         if(empty($idp_name)) {
             drupal_set_message(t('The <b>IDP Name</b> field is required.'), 'error');
         }
         if(empty($issuer)) {
             drupal_set_message(t('The <b>IdP Entity ID or Issuer</b> field is required.'), 'error');
         }
         if(empty($login_url)) {
             drupal_set_message(t('The <b>SAML Login URL</b> field is required.'), 'error');
         }
         return;
     }
  if ($enable_login == 1) {
    $enable_login = TRUE;
  }
  else {
    $enable_login = FALSE;
  }


  $sp_issuer = $base_url;
  variable_set('miniorange_saml_idp_name', $idp_name);
  variable_set('miniorange_saml_sp_issuer', $sp_issuer);
  variable_set('miniorange_saml_idp_issuer', $issuer);
  variable_set('miniorange_nameid_format',$nameid_format);
  variable_set('miniorange_saml_idp_login_url', $login_url);
  variable_set('miniorange_saml_idp_x509_certificate', $x509_cert_value);
  variable_set('miniorange_saml_enable_login', $enable_login);

  drupal_set_message(t('Identity Provider Configuration successfully saved'));

 }
 
function miniorange_saml_upload_file($form, &$form_state) {
    $idp_name = $form['miniorange_saml_idp_name_3']['#value'];
    if(empty($idp_name)&&empty(variable_get('miniorange_saml_idp_name')))
    {
        drupal_set_message(t('The <b>IDP Name</b> field is required.'), 'error');
    }
	$file_name = $_FILES['files']['tmp_name']['metadata_file'];
	$file = file_get_contents($file_name);
	upload_metadata($file,$idp_name);
}

function miniorange_saml_fetch_metadata($form, &$form_state) {

    $idp_name = $form['miniorange_saml_idp_name_3']['#value'];
    if(empty($idp_name)&&empty(variable_get('miniorange_saml_idp_name')))
    {
        drupal_set_message(t('The <b>IDP Name</b> field is required.'), 'error');
    }
	$url=filter_var($form['metadata_URL']['#value'],FILTER_SANITIZE_URL);
	$arrContextOptions=array(
				"ssl"=>array(
				"verify_peer"=>false,
				"verify_peer_name"=>false,
				),
			);  
	$file = file_get_contents($url, false, stream_context_create($arrContextOptions));
	upload_metadata($file,$idp_name);
}

function upload_metadata($file,$idp_name)
{
	global $base_url;
	require_once drupal_get_path('module', 'miniorange_saml') . DIRECTORY_SEPARATOR . 'includes' . DIRECTORY_SEPARATOR . 'MetadataReader.php';
	$document = new DOMDocument();
	$document->loadXML($file);
	restore_error_handler();
	$first_child = $document->firstChild;
	if(!empty($first_child))
	{
		$metadata = new IDPMetadataReader($document);
		$identity_providers = $metadata->getIdentityProviders();
		if(empty($identity_providers))
		{
			drupal_set_message(t('Please provide a valid metadata file.'),error);
			return;
		}
		foreach($identity_providers as $key => $idp)
		{
			$saml_login_url = $idp->getLoginURL('HTTP-Redirect');
			if(empty($saml_login_url)) {
				$saml_login_url = $idp->getLoginURL('HTTP-POST');
			}
			$saml_issuer = $idp->getEntityID();
			$saml_x509_certificate = $idp->getSigningCertificate();
            $sp_issuer = $base_url;
            if(!empty(variable_get('miniorange_saml_idp_name'))&& empty($idp_name)){
                $idp_name = variable_get('miniorange_saml_idp_name');
                variable_set('miniorange_saml_idp_name', $idp_name);
            }
            else{
                variable_set('miniorange_saml_idp_name', $idp_name);
            }

			variable_set('miniorange_saml_sp_issuer', $sp_issuer);
			variable_set('miniorange_saml_idp_issuer', $saml_issuer);
			variable_set('miniorange_saml_idp_login_url', $saml_login_url);
			variable_set('miniorange_saml_idp_x509_certificate', $saml_x509_certificate[0]);
		}
		drupal_set_message(t('Identity Provider Configuration successfully saved.'));
		return;
	}
	else {
		drupal_set_message(t('Please provide a valid metadata file.'),'error');
		return;
	}
}

/**
 * Send support query.
 */
function send_support_query(&$form, $form_state)
{
    Utilities::send_query($form, $form_state);
}