<?php
/**
 * @file
 * Contains Service Provider information for miniOrange SAML Login Module.
 */

 /**
 * Showing IdP Setup form info.
 */
include "mo_saml_visualTour.php";
 function miniorange_saml_proxy_setup($form, &$form_state) {

     global $base_url;

     $form['markup_msg'] = array(
         '#markup' => '<div class="mo_saml_idp_message"><p>If you are looking for an Identity Provider, you can try out <a href="https://idp.miniorange.com" target="_blank" style="color: #83cfff;">miniOrange On-Premise IdP</a></p></div>'
     );

  $form['header1'] = array(
    '#markup' => '<div class="mo_saml_table_layout_1"><div class="mo_saml_table_layout mo_saml_container" id="mo_saml_vt_phost"><br>',
  );

     $form['markup_top'] = array(
         '#markup' => '<b><span style="font-size: 17px;">CONFIGURE PROXY SERVER</span></b><a class="btn btn-primary btn-large restart_button" id="restart_tour_button">'
             . 'Take a Tour</a><br><br><hr><br/>'
     );

  $form['header2'] = array(
    '#markup' => 'Enter the information to setup the proxy server.',
  ); 
  
  $form['miniorange_saml_proxy_host'] = array(
    '#type' => 'textfield',
    '#title' => t('Proxy Host Name'),
    '#default_value' => variable_get('miniorange_saml_proxy_host', ''),
    '#attributes' => array('style' => 'width:68%','id'=>'mo_saml_vt_phost','placeholder' => 'Enter the host name'),
  );
  
  $form['miniorange_saml_proxy_port'] = array(
    '#type' => 'textfield',
    '#title' => t('Port Number'),
    '#default_value' => variable_get('miniorange_saml_proxy_port', ''),
    '#attributes' => array('style' => 'width:68%','id'=>'mo_saml_vt_pport','placeholder' => 'Enter the port number of the proxy'),
  );
  
  $form['miniorange_saml_proxy_username'] = array(
    '#type' => 'textfield',
    '#title' => t('Proxy Username'),
    '#default_value' => variable_get('miniorange_saml_proxy_username', ''),
    '#attributes' => array('style' => 'width:68%','id'=>'mo_saml_vt_pusername','placeholder' => 'Enter the username of the proxy server'),
  );
  
  $form['miniorange_saml_proxy_password'] = array(
    '#type' => 'password',
    '#title' => t('Password'),
    '#default_value' => variable_get('miniorange_saml_proxy_password', ''),
    '#attributes' => array('style' => 'width:68%','id'=>'mo_saml_vt_ppassword','placeholder' => 'Enter the password of the poxy server'),
  );

  $form['miniorange_saml_proxy_submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save'),
    '#submit' => array('miniorange_saml_save_proxy'),
    '#attributes' => array('style' => 'background: #337ab7;color: #ffffff;text-shadow: 0 -1px 1px #337ab7, 1px 0 1px #337ab7, 0 1px 1px #337ab7, -1px 0 1px #337ab7;box-shadow: 0 1px 0 #337ab7;border-color: #337ab7 #337ab7 #337ab7;'),
  );

  $form['miniorange_saml_proxy_reset_submit'] = array(
     '#type' => 'submit',
     '#value' => t('Reset'),
     '#submit' => array('miniorange_saml_reset_proxy'),
     '#attributes' => array('style' => 'background: #337ab7;color: #ffffff;text-shadow: 0 -1px 1px #337ab7, 1px 0 1px #337ab7, 0 1px 1px #337ab7, -1px 0 1px #337ab7;box-shadow: 0 1px 0 #337ab7;border-color: #337ab7 #337ab7 #337ab7;'),
  );

     $form['markup_div_imp11']=array('#markup'=>'</div>');

     Utilities::supportForm($form, $form_state);

     $form['miniorange_saml_support_submit_click'] = array(
         '#type' => 'submit',
         '#value' => t('Submit Query'),
         '#submit' => array('send_support_query'),
         '#attributes' => array('style' => 'background: #337ab7;color: #ffffff;text-shadow: 0 -1px 1px #337ab7, 1px 0 1px #337ab7, 0 1px 1px #337ab7, -1px 0 1px #337ab7;box-shadow: 0 1px 0 #337ab7;border-color: #337ab7 #337ab7 #337ab7;display:block;margin-left:auto;margin-right:auto;'),
     );

     $form['miniorange_saml_support_note'] = array(
         '#markup' => '<div>If you want custom features in the plugin, just drop an email to <a href="mailto:info@miniorange.com">info@miniorange.com</a></div></div></div>'
     );

  return $form;

 }

 /**
 * Configure Proxy Server.
 */

function miniorange_saml_save_proxy($form, &$form_state) {
  
  $proxy_host = $form['miniorange_saml_proxy_host']['#value'];
  $port_number = $form['miniorange_saml_proxy_port']['#value'];
  $proxy_username = $form['miniorange_saml_proxy_username']['#value'];
  $proxy_password = $form['miniorange_saml_proxy_password']['#value'];

    if(empty($proxy_host)||empty($port_number)||empty($proxy_username)||empty($proxy_password)){
        drupal_set_message(t('The <b>Proxy Host name, Port Number, Proxy Username</b> and <b>Proxy Password</b> fields are required.'), 'error');
        return;
    }

  variable_set('miniorange_saml_proxy_host',$proxy_host);
  variable_set('miniorange_saml_proxy_port',$port_number);
  variable_set('miniorange_saml_proxy_username',$proxy_username);
  variable_set('miniorange_saml_proxy_password',$proxy_password );
  drupal_set_message(t('Your configuration has been saved successfully.'));

}

function miniorange_saml_reset_proxy($form, $form_State)
{
    variable_del('miniorange_saml_proxy_host');
    variable_del('miniorange_saml_proxy_port');
    variable_del('miniorange_saml_proxy_username');
    variable_del('miniorange_saml_proxy_password' );
}
/**
 * Send support query.
 */
function send_support_query(&$form, $form_state)
{
    Utilities::send_query($form, $form_state);
}