<?php
/**
 * @file
 * Contains support form for miniOrange SAML Login Module.
 */

 function miniorange_saml_support($form, &$form_state) {

     $form['markup_msg'] = array(
         '#markup' => '<div class="mo_saml_idp_message"><p>If you are looking for an Identity Provider, you can try out <a href="https://idp.miniorange.com" target="_blank" style="color: #83cfff;">miniOrange On-Premise IdP</a></p></div>'
     );

     $form['markup_1'] = array(
        '#markup' => '<div class="mo_saml_table_layout_1"><div class="mo_saml_table_layout mo_saml_container"><h3>Support</h3><hr><br><div>Need any help? Just send us a query so we can help you.<br /><br /></div>'
     );

  $form['miniorange_saml_email_address'] = array(
    '#type' => 'textfield',
    '#title' => t('Email Address'),
    '#attributes' => array(
        'style' => 'width:68%','placeholder' => 'Enter your email'
    ),
    '#required' => TRUE,
  );

  $form['miniorange_saml_phone_number'] = array(
    '#type' => 'textfield',
    '#title' => t('Phone number'),
    '#attributes' => array(
        'style' => 'width:68%', 'placeholder' => 'Enter your phone number'
    ),
  );

  $form['miniorange_saml_support_query'] = array(
    '#type' => 'textarea',
    '#title' => t('Query'),
    '#cols' => '10',
    '#rows' => '5',
    '#attributes' => array(
        'style' => 'width:68%', 'placeholder' => 'Write your query here'
    ),
    '#required' => TRUE,
      '#resizable'=>False,
  );

  $form['miniorange_saml_support_submit'] = array(
    '#type' => 'submit',
    '#value' => t('Submit Query'),
    '#submit' => array('miniorange_saml_send_query'),

  );

  return $form;
 }

 function miniorange_saml_send_query($form, &$form_state) {
    $email = $form['miniorange_saml_email_address']['#value'];
    $phone = $form['miniorange_saml_phone_number']['#value'];
    $query = $form['miniorange_saml_support_query']['#value'];
    $support = new MiniOrangeSamlSupport($email, $phone, $query);
    $support_response = $support->sendSupportQuery();
    if($support_response) {
      drupal_set_message(t('Support query successfully sent'));
    }
    else {
    	drupal_set_message(t('Error sending support query'), 'error');
    } 
 }