<?php
/**
 * @file
 * Contains Service Provider information for miniOrange SAML Login Module.
 */

/**
 * Showing Service Provider information.
 */

include "mo_saml_visualTour.php";
function miniorange_sp_information($form, &$form_state)
{
    drupal_add_css( drupal_get_path('module', 'miniorange_saml'). '/css/bootstrap.min.css' , array('group' => CSS_DEFAULT, 'every_page' => FALSE));
    drupal_add_css( drupal_get_path('module', 'miniorange_saml'). '/css/style_settings.css' , array('group' => CSS_DEFAULT, 'every_page' => FALSE));
    drupal_add_css( drupal_get_path('module', 'miniorange_saml'). '/css/mo-card.css' , array('group' => CSS_DEFAULT, 'every_page' => FALSE));

    global $base_url;

    $form['markup_msg'] = array(
        '#markup' => '<div class="mo_saml_idp_message"><p>If you are looking for an Identity Provider, you can try out <a href="https://idp.miniorange.com" target="_blank" style="color: #83cfff;">miniOrange On-Premise IdP</a></p></div>'
    );

    $form['mo_overlay_header'] = array('#markup' => '<div class="mo_overlay" style="display:none"></div>');

    $form['header_top_style_1'] = array('#markup' => '<div class="mo_saml_table_layout_1">');

    $acs_url = $base_url . '/?q=samlassertion';

    $form['mo_overlay_box_display'] = array('#markup' => '<div class="mo_visual_tour_box" hidden id="mo_visual_tour_box"><div class="mo_saml_vt_h3"></div>
      <a class="btn btn-primary btn-large next_button">Next</a></div>');


    $form['markup_top'] = array(
        '#markup' => '<div class="mo_saml_table_layout mo_saml_container"><b><span style="font-size: 17px;">CONFIGURE IDENTITY PROVIDER</span></b><a class="btn btn-primary btn-large restart_button" id="restart_tour_button">'
            . 'Take a Tour</a><br><br><hr><br/>'
    );

    $module_path = drupal_get_path('module', 'miniorange_saml');

    $form['miniorange_saml_1'] = array(
        '#markup' => '<div id="mo_saml_custom_idp"><form><br>'

            .'<input type="radio" id="mo_saml_enable_cloud_broker" name="mo_saml_enable_cloud_broker" value="miniorange" onchange="display(this);" />Use miniOrange as an Identity Provider (IDP) ( <a href="#mo_idp" onclick="altdisplay(this);">Click Here</a> to know how the plugin works for this case. )<br/>'

            .'<input type="radio" id="mo_saml_enable_cloud_broker" name="mo_saml_enable_cloud_broker" value="true" onchange="display(this);" />Use miniOrange Identity broker service. (<a href="#mo_b_service" onclick="altdisplay(this);">Click Here</a> to know how the plugin works for this case. )<br/>'

            .'<input type="radio" id="mo_saml_enable_cloud_broker" name="mo_saml_enable_cloud_broker" value="false" checked="checked" onchange	="display(this);" />Use Your own Identity Provider ( <a href="#other_idp" onclick="altdisplay(this);">Click Here</a> to know how the plugin works for this case. )<br/>'
            .'</form>'

            .'<div id="mo_idp" style="display:none;">'
            .'<h3>Use miniOrange Identity broker service:</h3>'
            .'<div style="display:block;text-align:center;">'
            .'<img src="'. $base_url . '/' . $module_path . '/includes/images/drupalmo.png" alt="Working of miniOrange SAML plugin" style="width:30%;"/>'
            .'</div>'
            .'<ol>'
            .'<li>miniOrange SAML SSO plugin sends a login request to MiniOrange for authentication.</li>'
            .'<li>Upon successful authentication, MiniOrange sends a SAML Response back to miniOrange SAML SSO plugin. Plugin then reads the response and login the user.</li>'
            .'</ol>'
            .'<b>Advantages:</b>'
            .'<ol>'
            .'<li>The number of messages required for Single Sign On is less as your website is directly interacting with the Identity Provider.</li>'
            .'</ol>'
            .'</div>'

            .'<div id="mo_b_service" style="display:none;">'
            .'<h3>Use miniOrange Identity broker service:</h3>'
            .'<div style="display:block;text-align:center;">'
            .'<img src="'. $base_url . '/' . $module_path . '/includes/images/saml_working.png" alt="Working of miniOrange SAML plugin" style="width: 50%;"/>'
            .'</div>'
            .'<ol>'
            .'	<li>miniOrange SAML SSO plugin sends a login request to miniOrange SSO Service.</li>'
            .'	<li>miniOrange SSO Service creates a SAML Request and redirects the user to your Identity Provider for authentication.</li>'
            .'	<li>Upon successful authentication, your Identity Provider sends a SAML Response back to miniOrange SSO Service.</li>'
            .'	<li>miniOrange SSO Service verifies the SAML Response and sends a response status (along with the logged in user&#39;s information) back to miniOrange SAML SSO plugin. Plugin then reads the response and logins the user.</li>'
            .'</ol>'
            .'<div>'
            .'	<b>Advantages:</b>'
            .'	<ol>'
            .'		<li>If you are an enterprise or business user then on using this service you will be able to take full advantage of all of miniOrange SSO features. ( For a complete list of these features <a href="http://miniorange.com/single-sign-on-sso" target="_blank">Click Here</a>)</li>'
            .'		<li>You can use Non-SAML Identity Providers for Single Sign On.</li>'
            .'		<li>If you have multiple websites then you can use the same IdP configuration for all of them. You don&#39;t have to make seperate configurations in your IdP.</li>'
            .'		<li>Some Identity Providers like ADFS do not support HTTP endpoints ( i.e. your Drupal site needs to be on HTTPS ). So, if your Drupal site is not on HTTPS then you can use this service for such IdPs.</li>'
            .'	</ol>'

            .'</div>'
            .'</div>'
            .'</div>'
            .'<div id="other_idp" style="display:none;">'
            .'								<h3>Use Your own Identity Provider:</h3>'
            .'								<div style="display:block;text-align:center;">'
            .'								<img src="'. $base_url . '/' . $module_path . '/includes/images/saml_working_womo.png" alt="Working of miniOrange SAML plugin" style="width: 35%;"/>'
            .'								</div>'
            .'								<ol>'
            .'									<li>miniOrange SAML SSO plugin sends a login request to your Identity Provider for authentication.</li>'
            .'									<li>Upon successful authentication, your Identity Provider sends a SAML Response back to miniOrange SAML SSO plugin. Plugin then reads the response and login the user.</li>'
            .'								</ol>'

            .'								<div>'
            .'									<b>Advantages:</b>'
            .'									<ol>'
            .'										<li>The number of messages required for Single Sign On is less as your website is directly interacting with the Identity Provider.</li>'
            .'									</ol>'
            .'								</div>'
            .'							</div>'


            .'<div id="mo_miniorange_idp" style="display:none">',
    );

    $form['header_mo_idp'] = array(
        '#markup' => '<center><h3>You will need the following information to'
            . ' configure your IdP. Copy it and keep it handy.</h3></center>',
    );

    $header_mo_idp = array(
        'attribute' => array('data' => t('Attribute')),
        'value' => array('data' => t('Value')),
    );

    $options_mo_idp = array();

    $options_mo_idp[0] = array(
        'attribute' => t('Issuer'),
        'value' => $base_url,
    );

    $options_mo_idp[1] = array(
        'attribute' => t('ACS URL'),
        'value' => $acs_url,
    );

    $form['fieldset1']['spinfo_mo'] = array(
        '#theme' => 'table',
        '#header' => $header_mo_idp,
        '#rows' => $options_mo_idp,
    );

    $form['miniorange_saml_2'] = array(
        '#markup' => '<br><a href="https://plugins.miniorange.com/drupal-single-sign-sso-using-miniorange-idp/" target="_blank">Click Here to see the Guide for Configuring miniOrange as IdP. </a><br>'
            .'</div>'
            .'<div id="mo_miniorange_broker" style="display:none">',
    );

    $form['header_mo_broker'] = array(
        '#markup' => '<center><h3>You will need the following information to'
            . ' configure your IdP. Copy it and keep it handy</h3></center>',
    );

    $header_mo_broker = array(
        'attribute' => array('data' => t('Attribute')),
        'value' => array('data' => t('Value')),
    );

    $options_mo_broker = array();

    $options_mo_broker[0] = array(
        'attribute' => t('SP-EntityID / Issuer'),
        'value' => 'https://auth.miniorange.com/moas',
    );

    $options_mo_broker[1] = array(
        'attribute' => t('ACS (AssertionConsumerService) URL / Single Sign-On URL (SSO)'),
        'value' => 'https://auth.miniorange.com/moas/rest/saml/acs',
    );

    $options_mo_broker[2] = array(
        'attribute' => t('Single Logout URL (SLO)'),
        'value' => 'Available in the <a href="' . $base_url . '/admin/config/people/miniorange_saml/licensing"> <b>Premium</b></a> version',
    );

    $options_mo_broker[3] = array(
        'attribute' => t('Audience URI'),
        'value' => 'https://auth.miniorange.com/moas',
    );

    $options_mo_broker[4] = array(
        'attribute' => t('NameID Format'),
        'value' => 'urn:oasis:names:tc:SAML:1.1:nameid-format:emailAddress',
    );

    $options_mo_broker[5] = array(
        'attribute' => t('Default Relay State (Optional)'),
        'value' => 'Available in the <a href="' . $base_url . '/admin/config/people/miniorange_saml/licensing"> <b>Premium</b></a> version',
    );

    $form['fieldset_mo_broker']['spinfo_mo_broker'] = array(
        '#theme' => 'table',
        '#header' => $header_mo_broker,
        '#rows' => $options_mo_broker,
    );

    $form['markup_idp_sp'] = array(
        '#markup' => '<h3 align="center">OR</h3>',
    );

    $form['markup_idp_sp_1'] = array(
        '#markup' => '<b>You can provide this metadata URL to your Service Provider.</b><br />',
    );

    $form['miniorange_saml_3'] = array(
        '#markup' => '<div class="mo_saml_highlight_background_note">'.
            '<a href="https://auth.miniorange.com/moas/metadata/sp-metadata.xml" id="metadata-link" target="_blank">https://auth.miniorange.com/moas/metadata/sp-metadata.xml</a></div>'
            .'</code>'
            .'</div>'
            .'<div id="mo_other_idp">',
    );

    $form['header'] = array(
        '#markup' => '<center><h3>You will need the following information to configure your IdP. Copy it and keep it handy</h3></center>',
    );

    $header = array(
        'attribute' => array('data' => t('Attribute')),
        'value' => array('data' => t('Value')),
    );

    $form['mosaml_vtId']=array(
            '#markup'=>'<div id="mo_saml_vt_id">'
    );
    $options = array();

    $options[0] = array(
        'attribute' => t('Issuer'),
        'value' => $base_url,
    );

    $options[1] = array(
        'attribute' => t('ACS URL'),
        'value' => $acs_url,
    );

    $options[2] = array(
        'attribute' => t('Audience URI'),
        'value' => $base_url,
    );

    $options[3] = array(
        'attribute' => t('Recipient URL'),
        'value' => $acs_url,
    );

    $options[4] = array(
        'attribute' => t('Destination URL'),
        'value' => $acs_url,
    );

    $options[5] = array(
        'attribute' => t('NameID Format'),
        'value' => 'urn:oasis:names:tc:SAML:1.1:nameid-format:emailAddress',
    );



    $form['fieldset']['spinfo'] = array(
        '#theme' => 'table',
        '#header' => $header,
        '#rows' => $options,
    );

    $form['mosaml_vtId_end']=array(
        '#markup'=>'</div>'
    );

    $form['markup_1_idp_sp'] = array(
        '#markup' => '<h3 align="center">OR</h3>',
    );

    $form['markup_1_idp_sp_1'] = array(
        '#markup' => '<div id="mo_saml_vt_metadata"><b>You can provide this metadata URL to your Service Provider.</b><br/>',
    );

    $form['markupsp_sp_md_2'] = array(
        '#markup' => '<div class="mo_saml_highlight_background_note">'
            . '<a target="_blank" href="' .  $base_url . '/' . $module_path . '/includes/metadata/metadata.php">' .  $base_url . '/' . $module_path . '/includes/metadata/metadata.php' . '</a></b></div>'
            .'</div>',
    );




    $form['markup_support_close1'] = array(
        '#markup' => '</div></div>',
    );

    Utilities::supportForm($form, $form_state);

    $form['miniorange_saml_support_submit_click'] = array(
        '#type' => 'submit',
        '#value' => t('Submit Query'),
        '#submit' => array('send_support_query'),
        '#attributes' => array('style' => 'background: #337ab7;color: #ffffff;text-shadow: 0 -1px 1px #337ab7, 1px 0 1px #337ab7, 0 1px 1px #337ab7, -1px 0 1px #337ab7;box-shadow: 0 1px 0 #337ab7;border-color: #337ab7 #337ab7 #337ab7;display:block;margin-left:auto;margin-right:auto;'),
    );

    $form['miniorange_saml_support_note'] = array(
        '#markup' => '<div>If you want custom features in the plugin, just drop an email to <a href="mailto:info@miniorange.com">info@miniorange.com</a></div></div></div>'
    );

    return $form;
}

/**
* Send support query.
 */
function send_support_query(&$form, $form_state)
{
    Utilities::send_query($form, $form_state);
}